function tm_eps_set_cntrl_chnl_state(buffer, pinfo, tree, tm_eps_ctrl_chnl, offset)

local f_scs_fail_status = ProtoField.uint8("tm_eps_ctrl_chnl.scs_fail_status", "Scs/Fail Status", base.DEC, {
    [0] = "EPS_CTRL_SUCCESS",
    [1] = "EPS_CTRL_COMM_ERR",
    [2] = "EPS_CTRL_PARAM_ERR",
    [3] = "EPS_CTRL_HW_ERR",
    [4] = "EPS_CTRL_ERR",
    [5] = "EPS_CTRL_BTRY_ERR",
    [6] = "EPS_CTRL_IN_PROG",
    [7] = "EPS_CTRL_FW_MISMATCH_ERR",
    [8] = "EPS_CTRL_CHNL_OVR_CUR_ERR",
    [9] = "EPS_CTRL_INVLD_CHNL"
})
local f_channel_number = ProtoField.uint8("tm_eps_ctrl_chnl.channel_number", "Channel Number", base.DEC)
local f_channel_state = ProtoField.uint8("tm_eps_ctrl_chnl.channel_state", "Channel State", base.DEC)

tm_eps_ctrl_chnl.fields = {f_scs_fail_status, f_channel_number, f_channel_state}

local subtree = tree:add(tm_eps_ctrl_chnl, buffer(), "TM SET EPS CTRL CHNL ST")


    subtree:add(f_scs_fail_status, buffer(offset, 1)) -- Byte 0: Scs/Fail Status
    offset = offset + 1
    subtree:add(f_channel_number, buffer(offset, 1)) -- Byte 1: Channel Number
    offset = offset + 1
    subtree:add(f_channel_state, buffer(offset, 1)) -- Byte 2: Channel State
    offset = offset + 1
end