function tm_get_eps_dev_hw_sts(buffer, pinfo, tree, tm_eps_ctrl_chnl, offset)

local f_scs_fail_status = ProtoField.uint8("tm_eps_ctrl_chnl.scs_fail_status", "Scs/Fail Status", base.DEC, {
    [0] = "Success",
    [1] = "Fail"
})

local status =
{
  "OFF",
  "ON",
  "RESTART",
  "BOOT",
  "SHUTDOWN",
  "ERROR"
}

local f_channel_hw_sts = ProtoField.uint8("tm_eps_ctrl_chnl.channel_hw_sts", "Channel HW Status", base.DEC)
local f_channel_sw_sts = ProtoField.uint8("tm_eps_ctrl_chnl.channel_sw_sts", "Channel SW Status", base.DEC)

-- Add the fields to the protocol
tm_eps_ctrl_chnl.fields = {f_scs_fail_status, f_channel_hw_sts, f_channel_sw_sts}

local subtree = tree:add(tm_eps_ctrl_chnl, buffer(), "TM GET EPS DEV HW STS")

    subtree:add(f_scs_fail_status, buffer(offset, 1)) -- Byte 0: Scs/Fail Status
    offset = offset + 1

    -- Parse and add channel statuses

    for i = 0, 28 do -- There are 29 channels, each with 2 bytes (HW + SW)
        
        subtree:add(buffer(offset, 2), string.format("Channel %d Status", i))
        local hw_sts = buffer(offset, 1):le_uint()
        subtree:add(f_channel_hw_sts, hw_sts):set_text(string.format("Channel HW status : %s",status[hw_sts + 1])) -- HW Status
        offset = offset + 1
        local sw_sts = buffer(offset, 1):le_uint()
        subtree:add(f_channel_sw_sts, sw_sts):set_text(string.format("Channel SW status : %s",status[sw_sts + 1]))-- SW Status
        offset = offset + 1
    end
end